;################################# SparkleXP v0.6 - 3 Gen 2007
;Copyright (C) 2007 SparkleSoft
;Coders: Luca Forina, Sergio Proietti e Simone Proietti
;
;This program is free software: you can redistribute it and/or modify
;it under the terms of the GNU General Public License as published by
;the Free Software Foundation, either version 3 of the License, or
;any later version.
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;You should have received a copy of the GNU General Public License
;along with this program.  If not, see http://www.gnu.org/licenses.

SetCompressor /FINAL bzip2
Name "SparkleXP"
OutFile "SparkleXP_06.exe"
InstallDir "$ProgramFiles\SparkleXP"
CRCCheck force
BrandingText "SparkleSoft"
!include MUI.nsh
!include NSISArray.nsh
!include registry.nsh
!include registry_mod.nsh
!insertmacro COPY_REGISTRY_KEY
!define MUI_INSTFILESPAGE_COLORS "04bef1 000000"
Var sid
Var version
Var upgrade
${Array} "Servizi" 74 50
${ArrayFunc} WriteList
${ArrayFunc} Read
${ArrayFunc} FreeUnusedMem
${Array} "Antivirus" 111 50
${ArrayFunc} WriteList
${ArrayFunc} Read
${ArrayFunc} FreeUnusedMem
${Array} "Firewall" 40 50
${ArrayFunc} WriteList
${ArrayFunc} Read
${ArrayFunc} FreeUnusedMem
${Array} "Internet" 14 50
${ArrayFunc} WriteList
${ArrayFunc} Read
${ArrayFunc} FreeUnusedMem
ReserveFile "${NSISDIR}\Plugins\InstallOptionsEx.dll"
ReserveFile "inis\select.ini"
ReserveFile "pics\antivirus.gif"
ReserveFile "pics\firewall.gif"
ReserveFile "pics\temi.gif"
ReserveFile "pics\condivisi.gif"
ReserveFile "pics\internet.gif"

Function un.onInit
InitPluginsDir
FunctionEnd

Function .onInit
StrCpy $version "0.6"
;################################# Check installer avviato
System::Call 'kernel32::CreateMutexA(i 0, i 0, t "myMutex") ?e'
Pop $R0
StrCmp $R0 0 +3
MessageBox MB_OK|MB_ICONINFORMATION $(INSTALLCHECK4)
Abort
;################################# Check versione Windows
GetVersion::WindowsName
Pop $R0
StrCmp $R0 'XP' +5
StrCmp $R0 'Server 2003' +4
StrCmp $R0 'Server 2003 R2' +3
MessageBox MB_OK|MB_ICONINFORMATION $(INSTALLCHECK2)
Abort
;################################# Check utente in uso
ReadRegStr $1 HKLM "SOFTWARE\Microsoft\Windows NT\CurrentVersion\Winlogon" "AltDefaultUserName"
StrCmp $1 "Administrator" 0 +3
MessageBox MB_OK|MB_ICONINFORMATION $(INSTALLCHECK5)
Abort
;################################# Check credenziali utente in uso
UserInfo::getAccountType
Pop $0
StrCmp $0 "Admin" +3
MessageBox MB_OK|MB_ICONINFORMATION $(INSTALLCHECK3)
Abort
;################################# Check se installato
ReadRegStr $3 HKLM "Software\SparkleXP" "Installed"
StrCmp $3 "yes" +2 fine
StrCmp $3 "1" +1 fine
MessageBox MB_YESNOCANCEL|MB_ICONINFORMATION $(INSTALLCHECK1) IDYES aggiorna IDNO rimuovi
Quit
rimuovi:
ReadRegStr $R1 HKLM "Software\SparkleXP" "InstallLocation"
ExecWait '"$R1\Uninstall.exe"'
Quit
aggiorna:
StrCpy $upgrade "yes"
Goto fine
fine:
;################################# Decompressione .ini
InitPluginsDir
File /oname=$PLUGINSDIR\select.ini "inis\select.ini"
File /oname=$PLUGINSDIR\internet.gif "pics\internet.gif"
File /oname=$PLUGINSDIR\firewall.gif "pics\firewall.gif"
File /oname=$PLUGINSDIR\antivirus.gif "pics\antivirus.gif"
File /oname=$PLUGINSDIR\condivisi.gif "pics\condivisi.gif"
File /oname=$PLUGINSDIR\temi.gif "pics\temi.gif"
WriteINIStr $PLUGINSDIR\select.ini "Field 6" "Text" $PLUGINSDIR\internet.gif
WriteINIStr $PLUGINSDIR\select.ini "Field 7" "Text" $PLUGINSDIR\firewall.gif
WriteINIStr $PLUGINSDIR\select.ini "Field 8" "Text" $PLUGINSDIR\antivirus.gif
WriteINIStr $PLUGINSDIR\select.ini "Field 9" "Text" $PLUGINSDIR\condivisi.gif
WriteINIStr $PLUGINSDIR\select.ini "Field 10" "Text" $PLUGINSDIR\temi.gif

;################################# Splashscreen
SetOutPath $TEMP
File /oname=spla.gif "pics\splash.gif"
NewAdvSplash::Show 2000 1000 500 0xbd3535 /NOCANCEL "$TEMP\spla.gif"
Sleep 100

FunctionEnd

Section "Install"
;################################# Check MD5
md5dll::GetMD5File "${NSISDIR}\makensis.exe"
Pop $0
;################################# Pulizia
StrCmp $upgrade "yes" +6 +1
Rename "c:\Documents and Settings\SparkleXP" "$TEMP\sparkle"
RMDir /r $TEMP\sparkle
;menu condivisi
ReadRegStr $1 HKCR "CLSID\{4622AD11-FF23-11d0-8D34-00A0C90F2719}" "" ;"menu avvio"
Rename "c:\Documents and Settings\Default User\$1\SharedMenu" "$TEMP\SharedStartMenu"
RMDir /r $TEMP\SharedStartMenu
;profilo hw 9
DeleteRegKey HKLM "SYSTEM\CurrentControlSet\Hardware Profiles\0009\"
DeleteRegKey HKLM "SYSTEM\CurrentControlSet\Control\IDConfigDB\Hardware Profiles\0009"
DeleteRegKey HKLM "SYSTEM\CurrentControlSet\Control\IDConfigDB\Alias\0009"
;################################# Copia files
SetOutPath $INSTDIR
File /r Files\*.*
CreateDirectory "$WINDIR\SparkleXP"
StrCmp $upgrade "yes" +5 +1
CreateDirectory "$WINDIR\System32\GroupPolicy\User\Scripts\Logon"
CreateDirectory "$WINDIR\System32\GroupPolicy\User\Scripts\Logoff"
Rename "scripton.exe" "$WINDIR\System32\GroupPolicy\User\Scripts\Logon\scripton.exe"
Rename "scriptoff.exe" "$WINDIR\System32\GroupPolicy\User\Scripts\Logoff\scriptoff.exe"
WriteUninstaller "$INSTDIR\Uninstall.exe"
;################################# Creazione Collegamenti
CreateDirectory "$SMPROGRAMS\SparkleXP"
CreateShortCut "$SMPROGRAMS\SparkleXP\Readme.lnk" $(README)
CreateShortCut "$SMPROGRAMS\SparkleXP\Uninstall.lnk" "$INSTDIR\uninstall.exe"
CreateShortCut "$SMPROGRAMS\SparkleXP\SparkleStats.lnk" "$INSTDIR\SparkleStats.exe"
CreateShortCut "c:\Documents and Settings\All Users\Desktop\SparkleStats.lnk" "$INSTDIR\SparkleStats.exe"
;################################# Copia Menu Start
StrCmp $upgrade "yes" +5 +1
ReadRegStr $1 HKCR "CLSID\{4622AD11-FF23-11d0-8D34-00A0C90F2719}" "" ;"menu avvio"
ReadRegStr $2 HKCU "Software\Microsoft\Windows\ShellNoRoam\MUICache" "@shell32.dll,-21782" ;"programmi"
CreateDirectory "c:\Documents and Settings\Default User\$1\SharedMenu"
CopyFiles /silent "$PROFILE\$1\$2\*.*" "c:\Documents and Settings\Default User\$1\SharedMenu"
;################################# Aggiunta voce in Installazione Applicazioni
WriteRegStr HKLM "Software\SparkleXP" "Version" "$version"
WriteRegStr HKLM "Software\SparkleXP" "InstallLocation" "$INSTDIR"
WriteRegStr HKLM "Software\SparkleXP" "Installed" "yes"
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\SparkleXP" "DisplayName" "SparkleXP"
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\SparkleXP" "UninstallString" "$INSTDIR\Uninstall.exe"
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\SparkleXP" "InstallLocation" "$INSTDIR"
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\SparkleXP" "HelpLink" "http://www.sparklexp.com"
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\SparkleXP" "DisplayIcon" "$INSTDIR\icon.ico"
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\SparkleXP" "DisplayVersion" "$version"
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\SparkleXP" "Publisher" "SparkleSoft"
;################################# Nuovo utente
StrCmp $upgrade "yes" upgrade +1
ExecDos::exec "net user SparkleXP /add" "" ""
ExecDos::exec "net localgroup administrators SparkleXP /add" "" ""
;################################# SparkleXP SID
System::Call '*(&w${NSIS_MAX_STRLEN})i.R8'
System::Call 'advapi32::LookupAccountNameW(w ,w "SparkleXP",i R8, *i ${NSIS_MAX_STRLEN}, w .R1, *i ${NSIS_MAX_STRLEN}, *i .r0)i .r1'
System::Call 'advapi32::ConvertSidToStringSid(i R8,*t .R1)i .r0'
StrCpy $sid $R1
;################################# Backup /Default/NTUSER.DAT
SetOutPath "c:\Documents and Settings\Default User"
ExecDos::exec "attrib -h ntuser.dat"
CopyFiles /silent "NTUSER.DAT" "$WINDIR\SparkleXP\NTUSER.BAK"
;################################# Hive del profilo DEFAULT
ExecDos::exec "reg load HKLM\Temphive NTUser.dat"
WriteRegStr HKLM "Temphive\Software\Policies\Microsoft\Windows\System\Scripts\Logon\0\0" "Script" "scripton.exe"
WriteRegStr HKLM "Temphive\Software\Policies\Microsoft\Windows\System\Scripts\Logon\0\0" "Parameters" ""
${registry::Write} "HKEY_LOCAL_MACHINE\Temphive\Software\Policies\Microsoft\Windows\System\Scripts\Logon\0\0" "ExecTime" "00000000000000000000000000000000" REG_QWORD $0
WriteRegStr HKLM "Temphive\Software\Policies\Microsoft\Windows\System\Scripts\Logon\0" "GPO-ID" "Local GPO"
WriteRegStr HKLM "Temphive\Software\Policies\Microsoft\Windows\System\Scripts\Logon\0" "SOM-ID" "Local"
WriteRegStr HKLM "Temphive\Software\Policies\Microsoft\Windows\System\Scripts\Logon\0" "FileSysPath" "$WINDIR\System32\GroupPolicy\User"
WriteRegStr HKLM "Temphive\Software\Policies\Microsoft\Windows\System\Scripts\Logon\0" "GPOName" "Criteri gruppo locale"
WriteRegStr HKLM "Temphive\Software\Policies\Microsoft\Windows\System\Scripts\Logon\0" "DisplayName" "Criteri gruppo locale"
WriteRegStr HKLM "Temphive\Software\Policies\Microsoft\Windows\System\Scripts\Logoff\0\0" "Script" "scriptoff.exe"
WriteRegStr HKLM "Temphive\Software\Policies\Microsoft\Windows\System\Scripts\Logoff\0\0" "Parameters" ""
${registry::Write} "HKEY_LOCAL_MACHINE\Temphive\Software\Policies\Microsoft\Windows\System\Scripts\Logoff\0\0" "ExecTime" "00000000000000000000000000000000" REG_QWORD $0
WriteRegStr HKLM "Temphive\Software\Policies\Microsoft\Windows\System\Scripts\Logoff\0" "GPO-ID" "Local GPO"
WriteRegStr HKLM "Temphive\Software\Policies\Microsoft\Windows\System\Scripts\Logoff\0" "SOM-ID" "Local"
WriteRegStr HKLM "Temphive\Software\Policies\Microsoft\Windows\System\Scripts\Logoff\0" "FileSysPath" "$WINDIR\System32\GroupPolicy\User"
WriteRegStr HKLM "Temphive\Software\Policies\Microsoft\Windows\System\Scripts\Logoff\0" "GPOName" "Criteri gruppo locale"
WriteRegStr HKLM "Temphive\Software\Policies\Microsoft\Windows\System\Scripts\Logoff\0" "DisplayName" "Criteri gruppo locale"
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Group Policy\State\$sid\Scripts\Logon\0\0" "Script" "scripton.exe"
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Group Policy\State\$sid\Scripts\Logon\0\0" "Parameters" ""
${registry::Write} "HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\Group Policy\State\$sid\Scripts\Logon\0\0" "ExecTime" "00000000000000000000000000000000" REG_QWORD $0
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Group Policy\State\$sid\Scripts\Logon\0" "GPO-ID" "Local GPO"
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Group Policy\State\$sid\Scripts\Logon\0" "SOM-ID" "Local"
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Group Policy\State\$sid\Scripts\Logon\0" "FileSysPath" "$WINDIR\System32\GroupPolicy\User"
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Group Policy\State\$sid\Scripts\Logon\0" "GPOName" "Criteri gruppo locale"
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Group Policy\State\$sid\Scripts\Logon\0" "DisplayName" "Criteri gruppo locale"
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Group Policy\State\$sid\Scripts\Logoff\0\0" "Script" "scriptoff.exe"
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Group Policy\State\$sid\Scripts\Logoff\0\0" "Parameters" ""
${registry::Write} "HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\Group Policy\State\$sid\Scripts\Logoff\0\0" "ExecTime" "00000000000000000000000000000000" REG_QWORD $0
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Group Policy\State\$sid\Scripts\Logoff\0" "GPO-ID" "Local GPO"
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Group Policy\State\$sid\Scripts\Logoff\0" "SOM-ID" "Local"
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Group Policy\State\$sid\Scripts\Logoff\0" "FileSysPath" "$WINDIR\System32\GroupPolicy\User"
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Group Policy\State\$sid\Scripts\Logoff\0" "GPOName" "Criteri gruppo locale"
WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Group Policy\State\$sid\Scripts\Logoff\0" "DisplayName" "Criteri gruppo locale"
WriteRegBin HKLM "Temphive\Control Panel\Desktop" "UserPreferencesMask" 90120380
WriteRegStr HKLM "Temphive\Control Panel\Desktop" "MenuShowDelay" "0"
WriteRegStr HKLM "Temphive\Control Panel\Desktop\WindowMetrics" "MinAnimate" "0"
DeleteRegValue HKLM "Temphive\Control Panel\Desktop" "SCRNSAVE.EXE"
WriteRegStr HKLM "Temphive\AppEvents\Schemes" "" ".None"
DeleteRegKey HKLM "Temphive\AppEvents\Schemes\Apps\.Default"
DeleteRegKey HKLM "Temphive\AppEvents\Schemes\Apps\Conf"
DeleteRegKey HKLM "Temphive\AppEvents\Schemes\Apps\Explorer"
WriteRegStr HKLM "Temphive\Software\Microsoft\Dfrg\BootOptimizeFunction" "enable" "n"
WriteRegBin HKLM "Temphive\Software\Microsoft\Windows\CurrentVersion\Explorer" "ShellState" 2400000033880000000000000000000000000000010000000D0000000000000000000000
WriteRegDWORD HKLM "Temphive\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "Hidden" 0x0000000001
WriteRegDWORD HKLM "Temphive\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "FriendlyTree" 0x0000000001
WriteRegDWORD HKLM "Temphive\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "HideIcons" 0x0000000000
WriteRegDWORD HKLM "Temphive\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "PersistBrowsers" 0x0000000000
WriteRegDWORD HKLM "Temphive\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "WebView" 0x0000000000
WriteRegDWORD HKLM "Temphive\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "WebViewBarricade" 0x0000000000
WriteRegDWORD HKLM "Temphive\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "SuperHidden" 0x0000000001
WriteRegDWORD HKLM "Temphive\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "ShowSuperHidden" 0x0000000001
WriteRegDWORD HKLM "Temphive\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "ShowCompColor" 0x0000000001
WriteRegDWORD HKLM "Temphive\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "HideFileExt" 0x0000000000
WriteRegDWORD HKLM "Temphive\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "ShowInfoTip" 0x0000000000
WriteRegDWORD HKLM "Temphive\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "NoLowDiskSpaceChecks" 0x0000000001
WriteRegDWORD HKLM "Temphive\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "ListviewAlphaSelect" 0x0000000000
WriteRegDWORD HKLM "Temphive\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "ListviewShadow" 0x0000000000
WriteRegDWORD HKLM "Temphive\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "ListviewWatermark" 0x0000000000
WriteRegDWORD HKLM "Temphive\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "SuperHidden" 0x0000000001
WriteRegDWORD HKLM "Temphive\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "TaskbarAnimations" 0x0000000000
WriteRegDWORD HKLM "Temphive\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "WebView" 0x0000000000
WriteRegDWORD HKLM "Temphive\Software\Microsoft\Windows\CurrentVersion\Explorer\Advanced" "EnableBalloonTips" 0x0000000000
WriteRegDWORD HKLM "Temphive\Software\Microsoft\Windows\CurrentVersion\Explorer\VisualEffects" "VisualFXSetting" 0x0000000002
WriteRegDWORD HKLM "Temphive\Software\Microsoft\Windows\CurrentVersion\Policies\Explorer" "HideRunAsVerb" 0x0000000001
WriteRegDWORD HKLM "Temphive\Software\Microsoft\Windows\CurrentVersion\Policies\Explorer" "NoLowDiskSpaceChecks" 0x0000000001
WriteRegDWORD HKLM "Temphive\Software\Microsoft\Windows\CurrentVersion\Policies\Explorer" "NoSimpleStartMenu" 0x0000000001
WriteRegDWORD HKLM "Temphive\Control Panel\Desktop" "ForegroundFlashCount" 0x0000000001
WriteRegStr HKLM "Temphive\Control Panel\Sound" "Beep" "no"
ExecShell "open" "reg" "unload HKLM\Temphive" SW_HIDE
Goto upgrade
;################################# Valori Selection
upgrade:
ReadINIStr $1 "$PLUGINSDIR\select.ini" "Field 1" "State"
ReadINIStr $2 "$PLUGINSDIR\select.ini" "Field 2" "State"
ReadINIStr $3 "$PLUGINSDIR\select.ini" "Field 3" "State"
ReadINIStr $4 "$PLUGINSDIR\select.ini" "Field 4" "State"
ReadINIStr $5 "$PLUGINSDIR\select.ini" "Field 5" "State"
;################################# Accesso al registro ON
StrCmp $4 "0" +1 +3
AccessControl::SetOnRegKey HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Run" "SparkleXP" "FullAccess"
AccessControl::SetOnRegKey HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnce" "SparkleXP" "FullAccess"
;################################# Delay BootLoader
WriteRegDWORD HKLM "SYSTEM\CurrentControlSet\Control\IDConfigDB\" "UserWaitInterval" 0x000000010
;################################# Profilo HW 1
WriteRegDWORD HKLM "SYSTEM\CurrentControlSet\Control\IDConfigDB\Alias\0009" "DockingState" 0x00000000
WriteRegDWORD HKLM "SYSTEM\CurrentControlSet\Control\IDConfigDB\Alias\0009" "Capabilities" 0x00000000
WriteRegDWORD HKLM "SYSTEM\CurrentControlSet\Control\IDConfigDB\Alias\0009" "DockID" 0x00000000
WriteRegDWORD HKLM "SYSTEM\CurrentControlSet\Control\IDConfigDB\Alias\0009" "SerialNumber" 0x00000000
WriteRegDWORD HKLM "SYSTEM\CurrentControlSet\Control\IDConfigDB\Alias\0009" "ProfileNumber" 0x00000009
;################################# Profilo HW 2
WriteRegStr HKLM "SYSTEM\CurrentControlSet\Control\IDConfigDB\Hardware Profiles\0009" "HwProfileGuid" "{ed3fd1a0-fc51-430f-9a4b-44c0d6d84156}"
WriteRegStr HKLM "SYSTEM\CurrentControlSet\Control\IDConfigDB\Hardware Profiles\0009" "FriendlyName" "SparkleXP"
WriteRegDWORD HKLM "SYSTEM\CurrentControlSet\Control\IDConfigDB\Hardware Profiles\0009" "PreferenceOrder" 0x00000001
WriteRegDWORD HKLM "SYSTEM\CurrentControlSet\Control\IDConfigDB\Hardware Profiles\0009" "DockState" 0x00000007
WriteRegDWORD HKLM "SYSTEM\CurrentControlSet\Control\IDConfigDB\Hardware Profiles\0009" "Aliasable" 0x00000000
;################################# Chiavi Antivirus
StrCmp $3 "0" +1 fws
StrCpy $R8 "0"
${Antivirus->Init}
${Antivirus->WriteList} "'ASPI32' 'AVKPROXY' 'AVKSERVICE' 'AVKWCTL' 'GDINTERCEPTOR' 'GDTDIINTERCEPTOR' 'HOOKCENTRE' 'AAVMKER4' 'ASWRDR' 'ASWTDI' 'ASWUPDSV' 'AVAST!_ANTIVIRUS' 'AVAST!_MAIL_SCANNER' 'AVAST!_WEB_SCANNER' 'AVG7ALRT' 'AVG7UPDSVC' 'AVGEMS' 'BDSS' 'FILESPY' 'LIVESRV' 'REGSPY' 'VSSERV' 'XCOMM' 'BACKWEB_PLUG-IN_-_4476822' 'F-SECURE_GATEKEEPER_HANDLER_STARTER' 'FSBWSYS' 'FSDFWD' 'FSHTTPS' 'FSMA' 'F-SECURE_FILTER' 'F-SECURE_GATEKEEPER' 'F-SECURE_RECOGNIZER' 'FSFW' 'KAVSVC' 'KLIF' 'KLMC' 'AVP' 'KL1' 'KLIF' 'MCUPDMGR.EXE' 'MCVSRTE' 'MCDETECT.EXE' 'MCSHIELD' 'MCTSKSHD.EXE' 'MCUPDMGR.EXE' 'MPFIREWL' 'MPFSERVICE' 'MPFSERVICE' 'MSKSERVICE' 'NAIAVFILTER1' 'AMON' 'NOD32KRN' 'CCEVTMGR' 'CCSETMGR' 'NAVAPSVC' 'NAVENG' 'NAVEX15' 'NPFMNTOR' 'NSCSERVICE' 'SAVRT' 'SAVRTPEL' 'SAVSCAN' 'SNDSRVC' 'SPBBCDRV' 'SPBBCSVC' 'SYMANTEC_CORE_LC' 'SYMDNS' 'SYMEVENT' 'SYMFW' 'SYMIDS' 'SYMIDSCO' 'SYMLCBRD' 'SYMNDIS' 'SYMREDRV' 'SYMTDI' 'CCEVTMGR' 'CCPWDSVC' 'CCSETMGR' 'CPOINT' 'DEFWATCH' 'DSAFLT' 'NAVENG' 'NAVEX15' 'NETFLT' 'PAVFNSVR' 'PAVPROC' 'PAVPRSRV' 'PAVSRV' 'PCCTLCOM' 'PNMSRV' 'PSIMSVC' 'SAVROAM' 'SAVRT' 'SAVRTPEL' 'SHLDDRV' 'SNDSRVC' 'SPBBCSVC' 'SYMANTEC_ANTIVIRUS' 'SYMEVENT' 'SYMREDRV' 'SYMTDI' 'TMFILTER' 'TMNTSRV' 'TMPFW' 'TMPREFLT' 'TMPROXY' 'TMTDI' 'TM_CFW' 'TPSRV' 'VSAPINT' 'WNMFLT'"
${Antivirus->FreeUnusedMem}
loop:
${Antivirus->Read} $R0 $R8
WriteRegDWORD HKLM "SYSTEM\CurrentControlSet\Hardware Profiles\0009\System\CurrentControlSet\Enum\ROOT\LEGACY_$R0\0000" "CSConfigFlags" 0x00000001
IntOp $R8 $R8 + 1
StrCmp $R8 "111" +2
Goto loop
${Antivirus->Delete}
;################################# Chiavi Firewall
fws:
StrCmp $2 "0" +1 int
StrCpy $R8 "0"
${Firewall->Init}
${Firewall->WriteList} "'VSDATANT' 'VSMON' 'UMXPOL' 'UMXLU' 'UMXFWHLP' 'UMXCFG' 'UMXAGENT' 'KMXNDIS' 'KMXIDS' 'KMXFW' 'KMXCFG' 'WPSDRVNT' 'WG6N' 'WG5N' 'WG4N' 'WG3N' 'TEEFER' 'SMCSERVICE' 'VFILT' 'SECRET.DLL' 'PROTECT.DLL' 'POP3FILT.DLL' 'OUTPOSTFIREWALL' 'NNTPFILT.DLL' 'MAILFILT.DLL' 'IMAPFILT.DLL' 'HTTPFILT.DLL' 'HTMLFILT.DLL' 'FTPFILT.DLL' 'DNSCACHE.DLL' 'CONTENT.DLL' 'ARP.DLL' 'ADBLOCK.DLL' 'LNSSVC' 'LNSFW1' 'KPF4' 'KHIPS' 'FWDRV' 'VSMON' 'VSDATANT'"
${Firewall->FreeUnusedMem}
loop2:
${Firewall->Read} $R0 $R8
WriteRegDWORD HKLM "SYSTEM\CurrentControlSet\Hardware Profiles\0009\System\CurrentControlSet\Enum\ROOT\LEGACY_$R0\0000" "CSConfigFlags" 0x00000001
IntOp $R8 $R8 + 1
StrCmp $R8 "40" +2
Goto loop2
${Firewall->Delete}
WriteRegDWORD HKLM "SYSTEM\CurrentControlSet\Hardware Profiles\0009\System\CurrentControlSet\Enum\ROOT\LEGACY_S4E_LNSDRIVERMP\0001" "CSConfigFlags" 0x00000001
;################################# Chiavi Internet
int:
StrCmp $1 "0" +1 thm
StrCpy $R8 "0"
${Internet->Init}
${Internet->WriteList} "'DHCP' 'HTTP' 'IPNAT' 'TCPIP' 'NETMAN' 'WZCSVC' 'TAPISRV' 'RASMAN' 'WANARP' 'RASACD' 'NDPROXY' 'NDISTAPI' 'IPSEC' 'NETBT'"
${Internet->FreeUnusedMem}
loop3:
${Internet->Read} $R0 $R8
WriteRegDWORD HKLM "SYSTEM\CurrentControlSet\Hardware Profiles\0009\System\CurrentControlSet\Enum\ROOT\LEGACY_$R0\0000" "CSConfigFlags" 0x00000001
IntOp $R8 $R8 + 1
StrCmp $R8 "14" +2
Goto loop3
${Internet->Delete}
;################################# Chiavi Tema
thm:
StrCmp $5 "0" +1 srv
WriteRegDWORD HKLM "SYSTEM\CurrentControlSet\Hardware Profiles\0009\System\CurrentControlSet\Enum\ROOT\LEGACY_THEMES\0000" "CSConfigFlags" 0x00000001
Goto srv
;################################# Chiavi Servizi
srv:
StrCpy $R8 "0"
${Servizi->Init}
${Servizi->WriteList} "'ALERTER' 'ALG' 'APPMGMT' 'BROWSER' 'CISVC' 'CLIPSRV' 'COMSYSAPP' 'CRYPTSVC' 'DMADMIN' 'DMSERVER' 'DNSCACHE' 'ERSVC' 'FASTUSERSWITCHINGCOMPATIBILITY' 'HELPSVC' 'HIDSERV' 'IMAPISERVICE' 'LANMANSERVER' 'LANMANWORKSTATION' 'LMHOSTS' 'MESSENGER' 'MNMSRVC' 'MSDTC' 'NETDDE' 'NETDDEDSDM' 'NETLOGON' 'NLA' 'NTLMSSP' 'NTMSSVC' 'POLICYAGENT' 'PROTECTEDSTORAGE' 'RASAUTO' 'RDSESSMGR' 'REMOTEACCESS' 'REMOTEREGISTRY' 'RPCLOCATOR' 'RSVP' 'SCARDSVR' 'SECLOGON' 'SHAREDACCESS' 'SHELLHWDETECTION' 'SPOOLER' 'SRSERVICE' 'SSDPSRV' 'STISVC' 'SWPRV' 'SYSMONLOG' 'TERMSERVICE' 'TLNTSVR' 'TRKWKS' 'UPNPHOST' 'UPS' 'VSS' 'W32TIME' 'WEBCLIENT' 'WINMGMT' 'WMDMPMSN' 'WMI' 'WMIAPSRV' 'WSCSVC' 'WUAUSERV' 'XMLPROV' 'MCTSKSHD.EXE' 'RPDCDD' 'SPEEDFAN' 'PDSCHED' 'PDENGINE' 'IPODSERVICE' 'IDRIVERT' 'DISKEEPER' 'BTHSERV' 'ATI_SMART' 'ATI_HOTKEY_POLLER' 'UMXPOL' 'UMXLU'"
${Servizi->FreeUnusedMem}
loop4:
${Servizi->Read} $R0 $R8
WriteRegDWORD HKLM "SYSTEM\CurrentControlSet\Hardware Profiles\0009\System\CurrentControlSet\Enum\ROOT\LEGACY_$R0\0000" "CSConfigFlags" 0x00000001
IntOp $R8 $R8 + 1
StrCmp $R8 "74" +2
Goto loop4
${Servizi->Delete}
;################################# Clona risoluzione schermo
${COPY_REGISTRY_KEY} HKLM "SYSTEM\CurrentControlSet\Hardware Profiles\0001\System\CurrentControlSet\Control\VIDEO" HKLM "SYSTEM\CurrentControlSet\Hardware Profiles\0009\System\CurrentControlSet\Control\VIDEO"
;################################# Accesso al registro OFF
StrCmp $4 "0" +1 +3
AccessControl::DenyOnRegKey HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Run" "SparkleXP" "FullAccess"
AccessControl::DenyOnRegKey HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnce" "SparkleXP" "FullAccess"
StrCmp $upgrade "yes" finito +1
SetOutPath "c:\Documents and Settings\Default User"
Rename "NTUSER.DAT.LOG" "$TEMP\NTUSER.DAT.LOG"
Rename "0" "$TEMP\0"
Rename "success" "$TEMP\success"
Delete "$TEMP\NTUSER.DAT.LOG"
Delete "$TEMP\0"
Delete "$TEMP\success"
SetRebootFlag true
Goto finito
finito:
SectionEnd

Section "Uninstall"
;################################# Voci nel registro
DeleteRegKey HKLM "Software\SparkleXP"
DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\SparkleXP"
;################################# SparkleXP SID
System::Call '*(&w${NSIS_MAX_STRLEN})i.R8'
System::Call 'advapi32::LookupAccountNameW(w ,w "SparkleXP",i R8, *i ${NSIS_MAX_STRLEN}, w .R1, *i ${NSIS_MAX_STRLEN}, *i .r0)i .r1'
System::Call 'advapi32::ConvertSidToStringSid(i R8,*t .R1)i .r0'
StrCpy $sid $R1
;################################# Utente
ExecDos::exec "net user SparkleXP /delete"
;################################# Cartelle
Push "$PROFILE"
Call un.GetParent
Pop $R0
RmDir /r $R0\SparkleXP
SetOutPath "$INSTDIR"
SetOutPath "..\"
RmDir /r $INSTDIR
SetOutPath "c:\Documents and Settings\Default User"
Rename "NTUSER.DAT.LOG" "$TEMP\NTUSER.DAT.LOG"
Rename "NTUSER.DAT.LOG" "$TEMP\NTUSER.DAT"
Rename "0" "$TEMP\0"
Rename "success" "$TEMP\success"
CopyFiles /silent "$WINDIR\SparkleXP\NTUSER.BAK" "NTUSER.DAT"
ReadRegStr $1 HKCR "CLSID\{4622AD11-FF23-11d0-8D34-00A0C90F2719}" "" ;"menu avvio"
Rename "$1\SharedMenu" "$TEMP\SharedStartMenu"
Rename "c:\Documents and Settings\All Users\Desktop\SparkleStats.lnk" "$TEMP\SparkleStats.lnk"
Rename "$WINDIR\System32\GroupPolicy\User\Scripts\Logon\scripton.exe" "$TEMP\scripton.exe"
Rename "$WINDIR\System32\GroupPolicy\User\Scripts\Logoff\scriptoff.exe" "$TEMP\scriptoff.exe"
RMDir /r $WINDIR\SparkleXP
RMDir /r $SMPROGRAMS\SparkleXP
Delete "$TEMP\NTUSER.DAT.LOG"
Delete "$TEMP\NTUSER.DAT"
Delete "$TEMP\0"
Delete "$TEMP\success"
Delete "$TEMP\SparkleStats.lnk"
Delete "$TEMP\scripton.exe"
Delete "$TEMP\scriptoff.exe"
RMDir /r $TEMP\SharedStartMenu
;################################# Accesso al registro ON
AccessControl::SetOnRegKey HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Run" "SparkleXP" "FullAccess"
AccessControl::SetOnRegKey HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\RunOnce" "SparkleXP" "FullAccess"
;################################# Profilo Utente
DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Group Policy\$sid"
DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Group Policy\State\$sid"
DeleteRegKey HKLM "Software\Microsoft\Windows NT\CurrentVersion\ProfileList\$sid"
;################################# Profilo Hardware
DeleteRegKey HKCR "exefile\shell\SparkleH"
DeleteRegKey HKLM "SYSTEM\CurrentControlSet\Hardware Profiles\0009\"
DeleteRegKey HKLM "SYSTEM\CurrentControlSet\Control\IDConfigDB\Hardware Profiles\0009"
DeleteRegKey HKLM "SYSTEM\CurrentControlSet\Control\IDConfigDB\Alias\0009"
SectionEnd

Function un.GetParent
Exch $R0
Push $R1
Push $R2
Push $R3
StrCpy $R1 0
StrLen $R2 $R0
loop:
IntOp $R1 $R1 + 1
IntCmp $R1 $R2 get 0 get
StrCpy $R3 $R0 1 -$R1
StrCmp $R3 "\" get
Goto loop
get:
StrCpy $R0 $R0 -$R1
Pop $R3
Pop $R2
Pop $R1
Exch $R0
FunctionEnd

;################################# Settaggi Interfaccia
!define MUI_ABORTWARNING
!define MUI_UNABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\SparkleXP-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\SparkleXP-uninstall.ico"
;################################# Pagine Installazione
!insertmacro MUI_PAGE_WELCOME
!insertmacro MUI_PAGE_LICENSE "docs\license.txt"
!insertmacro MUI_PAGE_DIRECTORY
Page custom CustomPageSelect
!insertmacro MUI_PAGE_INSTFILES
!insertmacro MUI_PAGE_FINISH
;################################# Pagine Disinstallazione
!insertmacro MUI_UNPAGE_CONFIRM
!insertmacro MUI_UNPAGE_INSTFILES
!insertmacro MUI_UNPAGE_FINISH
;################################# Lingue Supportate
!insertmacro MUI_LANGUAGE "English"
!insertmacro MUI_LANGUAGE "French"
!insertmacro MUI_LANGUAGE "German"
!insertmacro MUI_LANGUAGE "Spanish"
!insertmacro MUI_LANGUAGE "Italian"
!insertmacro MUI_LANGUAGE "Russian"
;################################# Documenti ReadMe
LangString README ${LANG_ENGLISH} "$INSTDIR\readme_eng.txt"
LangString README ${LANG_FRENCH} "$INSTDIR\readme_eng.txt"
LangString README ${LANG_GERMAN} "$INSTDIR\readme_eng.txt"
LangString README ${LANG_SPANISH} "$INSTDIR\readme_eng.txt"
LangString README ${LANG_RUSSIAN} "$INSTDIR\readme_eng.txt"
LangString README ${LANG_ITALIAN} "$INSTDIR\readme_ita.txt"
;################################# Stringhe Linguaggi
LangString INSTALLCHECK1 ${LANG_ENGLISH} "SparkleXP is already installed, do you want to update it?"
LangString INSTALLCHECK1 ${LANG_FRENCH} "SparkleXP is already installed, do you want to update it?"
LangString INSTALLCHECK1 ${LANG_GERMAN} "SparkleXP is already installed, do you want to update it?"
LangString INSTALLCHECK1 ${LANG_SPANISH} "SparkleXP is already installed, do you want to update it?"
LangString INSTALLCHECK1 ${LANG_RUSSIAN} "SparkleXP is already installed, do you want to update it?"
LangString INSTALLCHECK1 ${LANG_ITALIAN} "SparkleXP  giinstallato, vuoi aggiornarlo?"
LangString INSTALLCHECK2 ${LANG_ENGLISH} "SparkleXP can be installed only on Windows XP and Server 2003"
LangString INSTALLCHECK2 ${LANG_FRENCH} "SparkleXP can be installed only on Windows XP and Server 2003"
LangString INSTALLCHECK2 ${LANG_GERMAN} "SparkleXP can be installed only on Windows XP and Server 2003"
LangString INSTALLCHECK2 ${LANG_SPANISH} "SparkleXP can be installed only on Windows XP and Server 2003"
LangString INSTALLCHECK2 ${LANG_RUSSIAN} "SparkleXP can be installed only on Windows XP and Server 2003"
LangString INSTALLCHECK2 ${LANG_ITALIAN} "SparkleXP pu essere installato solo su Windows XP e Server 2003"
LangString INSTALLCHECK3 ${LANG_ENGLISH} "You must have administrator rights to install SparkleXP! Retry with another user"
LangString INSTALLCHECK3 ${LANG_FRENCH} "You must have administrator rights to install SparkleXP! Retry with another user"
LangString INSTALLCHECK3 ${LANG_GERMAN} "You must have administrator rights to install SparkleXP! Retry with another user"
LangString INSTALLCHECK3 ${LANG_SPANISH} "You must have administrator rights to install SparkleXP! Retry with another user"
LangString INSTALLCHECK3 ${LANG_RUSSIAN} "You must have administrator rights to install SparkleXP! Retry with another user"
LangString INSTALLCHECK3 ${LANG_ITALIAN} "Devi avere diritti da amministratore per installare SparkleXP! Riprova con un altro utente"
LangString INSTALLCHECK4 ${LANG_ENGLISH} "The installer is already running!"
LangString INSTALLCHECK4 ${LANG_FRENCH} "The installer is already running!"
LangString INSTALLCHECK4 ${LANG_GERMAN} "The installer is already running!"
LangString INSTALLCHECK4 ${LANG_SPANISH} "The installer is already running!"
LangString INSTALLCHECK4 ${LANG_RUSSIAN} "The installer is already running!"
LangString INSTALLCHECK4 ${LANG_ITALIAN} "L'installer  gia avviato!"
LangString INSTALLCHECK5 ${LANG_ENGLISH} "SparkleXP can not be installed by the Administrator user! Retry with another user"
LangString INSTALLCHECK5 ${LANG_FRENCH} "SparkleXP can not be installed by the Administrator user! Retry with another user"
LangString INSTALLCHECK5 ${LANG_GERMAN} "SparkleXP can not be installed by the Administrator user! Retry with another user"
LangString INSTALLCHECK5 ${LANG_SPANISH} "SparkleXP can not be installed by the Administrator user! Retry with another user"
LangString INSTALLCHECK5 ${LANG_RUSSIAN} "SparkleXP can not be installed by the Administrator user! Retry with another user"
LangString INSTALLCHECK5 ${LANG_ITALIAN} "SparkleXP non pu essere installato dall'utente Administrator! Riprovare con un altro utente"
LangString SELECT_HEADER1 ${LANG_ENGLISH} "New desktop settings"
LangString SELECT_HEADER1 ${LANG_FRENCH} "New desktop settings"
LangString SELECT_HEADER1 ${LANG_GERMAN} "New desktop settings"
LangString SELECT_HEADER1 ${LANG_SPANISH} "New desktop settings"
LangString SELECT_HEADER1 ${LANG_RUSSIAN} "New desktop settings"
LangString SELECT_HEADER1 ${LANG_ITALIAN} "Impostazioni nuovo desktop"
LangString SELECT_HEADER2 ${LANG_ENGLISH} "Select features to keep enabled in the new desktop"
LangString SELECT_HEADER2 ${LANG_FRENCH} "Select features to keep enabled in the new desktop"
LangString SELECT_HEADER2 ${LANG_GERMAN} "Select features to keep enabled in the new desktop"
LangString SELECT_HEADER2 ${LANG_SPANISH} "Select features to keep enabled in the new desktop"
LangString SELECT_HEADER2 ${LANG_RUSSIAN} "Select features to keep enabled in the new desktop"
LangString SELECT_HEADER2 ${LANG_ITALIAN} "Seleziona le caratteristiche da abilitare nel nuovo desktop"
LangString SELECT1 ${LANG_ENGLISH} "Internet connection"
LangString SELECT1 ${LANG_FRENCH} "Internet connection"
LangString SELECT1 ${LANG_GERMAN} "Internet connection"
LangString SELECT1 ${LANG_SPANISH} "Internet connection"
LangString SELECT1 ${LANG_RUSSIAN} "Internet connection"
LangString SELECT1 ${LANG_ITALIAN} "Connessione ad Internet"
LangString SELECT2 ${LANG_ENGLISH} "Firewall solution"
LangString SELECT2 ${LANG_FRENCH} "Firewall solution"
LangString SELECT2 ${LANG_GERMAN} "Firewall solution"
LangString SELECT2 ${LANG_SPANISH} "Firewall solution"
LangString SELECT2 ${LANG_RUSSIAN} "Firewall solution"
LangString SELECT2 ${LANG_ITALIAN} "Firewall"
LangString SELECT3 ${LANG_ENGLISH} "Antivirus solution"
LangString SELECT3 ${LANG_FRENCH} "Antivirus solution"
LangString SELECT3 ${LANG_GERMAN} "Antivirus solution"
LangString SELECT3 ${LANG_SPANISH} "Antivirus solution"
LangString SELECT3 ${LANG_RUSSIAN} "Antivirus solution"
LangString SELECT3 ${LANG_ITALIAN} "Antivirus"
LangString SELECT4 ${LANG_ENGLISH} "Shared startup programs"
LangString SELECT4 ${LANG_FRENCH} "Shared startup programs"
LangString SELECT4 ${LANG_GERMAN} "Shared startup programs"
LangString SELECT4 ${LANG_SPANISH} "Shared startup programs"
LangString SELECT4 ${LANG_RUSSIAN} "Shared startup programs"
LangString SELECT4 ${LANG_ITALIAN} "Programmi d'avvio condivisi"
LangString SELECT5 ${LANG_ENGLISH} "Windows XP Visual Style"
LangString SELECT5 ${LANG_FRENCH} "Windows XP Visual Style"
LangString SELECT5 ${LANG_GERMAN} "Windows XP Visual Style"
LangString SELECT5 ${LANG_SPANISH} "Windows XP Visual Style"
LangString SELECT5 ${LANG_RUSSIAN} "Windows XP Visual Style"
LangString SELECT5 ${LANG_ITALIAN} "Interfaccia grafica di Windows XP"

;################################# Select
Function CustomPageSelect
!insertmacro MUI_HEADER_TEXT "$(SELECT_HEADER1)" "$(SELECT_HEADER2)"
WriteINIStr "$PLUGINSDIR\select.ini" "Field 1" "Text" $(SELECT1)
WriteINIStr "$PLUGINSDIR\select.ini" "Field 2" "Text" $(SELECT2)
WriteINIStr "$PLUGINSDIR\select.ini" "Field 3" "Text" $(SELECT3)
WriteINIStr "$PLUGINSDIR\select.ini" "Field 4" "Text" $(SELECT4)
WriteINIStr "$PLUGINSDIR\select.ini" "Field 5" "Text" $(SELECT5)
InstallOptionsEx::initDialog /NOUNLOAD $PLUGINSDIR\select.ini
InstallOptionsEx::show
FunctionEnd

